-----------------------------------------------------------------------------------------------
-- Client Lua Script for FastHoldToCast
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- FastHoldToCast Module Definition
-----------------------------------------------------------------------------------------------
local FastHoldToCast = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function FastHoldToCast:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function FastHoldToCast:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- FastHoldToCast OnLoad
-----------------------------------------------------------------------------------------------
function FastHoldToCast:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("FastHoldToCast.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- FastHoldToCast OnDocLoaded
-----------------------------------------------------------------------------------------------
function FastHoldToCast:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "FastHoldToCastForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("fhtc", "OnFastHoldToCastOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- FastHoldToCast Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/fhtc"
function FastHoldToCast:OnFastHoldToCastOn()
	self.wndMain:Invoke() -- show the window
end


-----------------------------------------------------------------------------------------------
-- FastHoldToCastForm Functions
-----------------------------------------------------------------------------------------------

function FastHoldToCast:OnButtonClick( wndHandler, wndControl, eMouseButton )
	Apollo.SetConsoleVariable("spell.holdToContinueCasting", not Apollo.GetConsoleVariable("spell.holdToContinueCasting"))
	if Apollo.GetConsoleVariable("spell.holdToContinueCasting") then
		self.wndMain:FindChild("ValueHoldToCast"):SetText("Hold to Cast switched on")
	else
		self.wndMain:FindChild("ValueHoldToCast"):SetText("Hold to Cast switched off")
	end
end

-----------------------------------------------------------------------------------------------
-- FastHoldToCast Instance
-----------------------------------------------------------------------------------------------
local FastHoldToCastInst = FastHoldToCast:new()
FastHoldToCastInst:Init()
